// GSV4TestApp.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


// gsv4test.cpp : defines the entry-point for the cosole application
//					

/********* Operation of the test program: Keyboard inputs
g: Input properties of specified channel
y: Start permanent transmission of measuring values
x: Stop permanent transmission of measuring values
f: Data frequency
l: Load settings (that were previously stored)
s: Store settings
m: read mode
n: Display scaling
z: Set specified channel 1..4 to zero  oder specify 0: All channels
q: Quit program
*/

#include <stdio.h>
#include <conio.h>
#include <iostream>
#include "MEGSV4w32.h"

using namespace std;

#define READ_MULTI	//Read blocks (Array) of mesuring values
#define MAINLOOPDELAY 100
//#define GSV4BLUETOOTH_BEFORE2012 //uncomment for GSV-4 BT older than by Jan. 2013
#define BAUDRATE_FIXED 115200

int main(int argc, char* argv[])
{
	int Comnr, ret, in,bit, mode, gain,i,j;
	long scal, actExFlags;
	long Baud;
	double Wert[4], Dtmp, nor[4], Zwert, norm;
	double Warr[2048];
	unsigned int Count=0;
	int Valsread;
	char Taste=0, t=0;
	char Ser[10];
//Begin:
	cout<<"Input ComNo: "<<endl<<flush;
	cin>>Comnr;
#ifdef BAUDRATE_FIXED
	Baud= BAUDRATE_FIXED;
#else
	cout<<"Input Baudrate: "<<endl<<flush;
	cin>>Baud;
#endif

	/********* FROM HERE: Necessary Start-sequence for GSV-4. 1st step: Open port and device. **********/
#ifdef GSV4BLUETOOTH_BEFORE2012
	actExFlags= ACTEX_FLAG_HANDSHAKE | ACTEX_FLAG_WAIT_EXTENDED;	//some older GSV4-BT requre this Flags )see megsv4.h)
#else
	actExFlags= 0;
#endif
	ret= GSV4activateExtended(Comnr, Baud, 512, actExFlags);
	cout<<"Result: "<<ret<<endl<<flush;
	if(ret==GSV_ERROR)
	{
		cout<<"GSV4getLastError: "<<GSV4getLastError(Comnr)<<endl<<flush; //If Error:
		printf(" Press any key...\n\n");
		_getch(); fflush(stdout); fflush(stdin);	//Show Errorcode and exit
		exit(0);
	}
	Sleep(500);
	mode= GSV4getMode(Comnr);	//If acivate was ok: 2nd step: Read Mode
	cout<<endl<<"GSV4getMode: "<<mode<<endl<<flush;
	if(mode==0)		//If GSV-4 in Mode 0: 
	{
		Sleep(500);	//wait 500ms 
		cout<<"GSV4setMode: "<<GSV4setMode(Comnr,1,"berlin")<<endl<<flush; //and set to  Mode 1
	}
	/********* //TO HERE: End of necessary Start-sequence for GSV-4  *******/
	Sleep(400);
	cout<<"GSV4readSerialNo: "<<GSV4readSerialNo(Comnr,Ser); //read SerNo 
	cout<<" No: "<<Ser<<endl<<flush;
	for(i=0;i<4;i++)
	{
		Sleep(200);
		nor[i]=GSV4DispGetNorm(Comnr,i+1);	//Read display scaling of all 4 input channels
		cout<<"GSV4DispGetNorm("<<i+1<<"): "<<nor[i]<<endl<<flush;
	}
	printf(" Press any key...\n\n");
	_getch(); fflush(stdout); fflush(stdin);
	GSV4startTX(Comnr);	//necessary only if oermanent value transmission disabled
	do	//MAINLOOP
	{
		Sleep(MAINLOOPDELAY);	//wait to limit CPU load
#ifdef READ_MULTI
		ret= GSV4readMultiple(Comnr,0,Warr,400,&Valsread);	//try to retrieve measuring values from dll buffer
#else
		ret= GSV4readAll(Comnr, &Wert[0], &Wert[1], &Wert[2], &Wert[3]);
#endif
		if(ret==GSV_TRUE)	//if measuring values were copied from buffer:
		{
#ifdef READ_MULTI
			for(i=0;i<(Valsread/4);i++)	//show all of them, scaled with display scaling
			{
				for(j=0;j<4;j++)
					Wert[j]= Warr[(i*4)+j]*nor[j];
				printf("Val1: %.5lf Val2: %.5lf Val3: %.5lf Val4: %.5lf\n",Wert[0],Wert[1],Wert[2],Wert[3]);
			}
#else
			printf("al1: %.5lf Val2: %.5lf Val3: %.5lf Val4: %.5lf\n",Wert[0]*nor[0],Wert[1]*nor[1],Wert[2]*nor[2],Wert[3]*nor[3]);
#endif
		}
		else if(ret==GSV_ERROR)
			printf("Error!\n");	//dll reports error
		if(_kbhit())	//Keyboard input
		{
			Taste= _getche();
			switch(Taste) //parse input
			{
			case 'c':	//read INTERNAL scaling factor of GSV-4
				cout<<" Channel (1..4): "<<endl<<flush;
				cin>>in;
				cout<<" Gain: "<<endl<<flush;
				cin>>gain;
				cout<<"MeGSV4getScale: "<<MeGSV4getScale(Comnr,in,gain)<<endl<<flush;
				break;
			case 'g':
				cout<<" Channel (1..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4getGain: "<<GSV4getGain(Comnr,in)<<endl<<flush;
				cout<<"Change Gain? (y / n): "<<flush;
				cin>>t;
				if(t=='y')
				{
					cout<<endl<<"New Gain: "<<flush;
					cin>>gain;
					cout<<endl<<"GSV4setGain: "<<GSV4setGain(Comnr, in, gain)<<endl<<flush;
					cout<<"GSV4getGain: "<<GSV4getGain(Comnr,in)<<endl<<flush;
				} break;
			case 'y':
				cout<<"GSV4startTX: "<<GSV4startTX(Comnr)<<endl<<flush; break;
			case 'x':
				cout<<"GSV4stopTX: "<<GSV4stopTX(Comnr)<<endl<<flush; break;
			case 'f':
				Dtmp= GSV4readFreq(Comnr);
				cout<<"GSV4readFreq: "<<Dtmp<<endl<<flush;
				cout<<"Change Freq? (y / n): "<<flush;
				cin>>t;
				if(t=='y')
				{
					cout<<endl<<"New Freq: "<<flush;
					cin>>Dtmp;
					cout<<endl<<"GSV4writeFreq: "<<GSV4writeFreq(Comnr, Dtmp)<<endl<<flush;
					cout<<" GSV4readFreq: "<<GSV4readFreq(Comnr)<<endl<<flush;
				} break;
			case 'l':
				cout<<"User-record-No (1..3): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4getAll: "<<GSV4getAll(Comnr,in)<<endl<<flush; break;
			case 'm':
				cout<<"GSV4getMode: "<<GSV4getMode(Comnr)<<endl<<flush; break;
			case 'n':
				cout<<" Channel (1..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4DispGetNorm: "<<GSV4DispGetNorm(Comnr,in)<<endl<<flush;
				cout<<"change scaling? (y / n): "<<flush;
				cin>>t;
				if(t=='y')
				{
					cout<<endl<<"New Norm: "<<flush;
					cin>>Dtmp;
					cout<<endl<<"GSV4DispSetNorm: "<<GSV4DispSetNorm(Comnr, in, Dtmp)<<endl<<flush;
					nor[in-1]= GSV4DispGetNorm(Comnr,in);
					cout<<" GSV4DispGetNorm: "<<nor[in-1]<<endl<<flush;
				} break;
			case 's':
				cout<<"User-record-No (1..3): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4saveAll: "<<GSV4saveAll(Comnr,in)<<endl<<flush; break;
			case 'r':
				cout<<"Channel (1..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4read: "<<GSV4read(Comnr, in, &Dtmp);
				cout<<"Value: "<<Dtmp<<endl<<flush; break;
			case 'v':
				cout<<"GSV4getValue: "<<GSV4getValue(Comnr)<<endl<<flush; break;
			case 'z':
				cout<<"Channel (0..4): "<<endl<<flush;
				cin>>in;
				cout<<"GSV4setZero: "<<GSV4setZero(Comnr,in)<<endl<<flush;
				cout<<"GSV4clearDLLbuffer: "<<GSV4clearDLLbuffer(Comnr)<<endl<<flush; break;
			default: break;
			}
			printf(" Press any key...\n\n");
			getch(); fflush(stdout); fflush(stdin);
		}

	} while(Taste!='q'); //End Mainloop

	ret= GSV4release(Comnr);	// close port and free ressources
	return 0;
}
